#! /usr/bin/python

import os
import urllib
import urllib2
from urllib2 import Request, urlopen, URLError
import csv
from cStringIO import StringIO
import xml.etree.ElementTree as ET
from datetime import date
import subprocess
from time import sleep

# Variables, input, and output files
input = open('LD_Book_VA_ZipCodes.txt', 'r') 
output = open('weatherData.ttl', 'w') 
today = date.today().strftime("%m-%d-%y")

print "\nStarting Fuseki..."
os.chdir("/Users/LukeRuth/Desktop/jena-fuseki-0.2.5/")  
args1 = ['./fuseki-server', '--update', '--mem', '/ds']
subprocess.Popen(args1)

sleep(10)  
print "\n"

print >>output, "@prefix rdfs: <http://www.w3.org/2000/01/rdf-schema#> ."
print >>output, "@prefix wh: <http://www.example.com/WeatherHealth/Schema#> .\n"

# Cycle through every zip code in the input file
for line in input: 
	zip = line
	zip = zip.rstrip()
	
	noaaQuery = "http://graphical.weather.gov/xml/sample_products/browser_interface/ndfdXMLclient.php?ZIP CodeList=" + zip + "&product=time-series&maxt=maxt&mint=mint"
	epaQuery = "http://iaspub.epa.gov/enviro/efservice/getEnvirofactsUVDAILY/ZIP/" + zip + "/CSV"
	 
	noaaReq = urllib2.Request(url=noaaQuery)
	try:
		noaaContents = urllib2.urlopen(noaaReq).read()
	except URLError, e:
		if hasattr(e, 'reason'):
			print'We failed to reach a server.'
			print 'Reason: ', e.reason
		elif hasattr(e, 'code'):
			print 'The server couldn\'t fulfill the request.'
			print 'Error code: ', e.code
	else:
		# Parse and obtain desired NOAA xml contents
		root = ET.fromstring(noaaContents)
		for temperature in root.findall(".//value/..[@type='maximum']"):
			maxTemp = temperature.find('value').text
		
		for temperature in root.findall(".//value/..[@type='minimum']"):
			minTemp = temperature.find('value').text
	 
	try:
		epaContents = urllib2.urlopen(epaQuery).read()
	except URLError, e:
		if hasattr(e, 'reason'):
			print'We failed to reach a server.'
			print 'Reason: ', e.reason
		elif hasattr(e, 'code'):
			print 'The server couldn\'t fulfill the request.'
			print 'Error code: ', e.code
	else:
		epaContents = epaContents.rstrip()
		# Loop through EPA CSV file and assign values to variables
		reader = csv.DictReader(StringIO(epaContents), delimiter=',')
		for row in reader:
			uvValue = row['UV_VALUE']
			uvAlert = row['UV_ALERT']
			   
	print >>output, "<http://www.example.com/WeatherHealth/ZipCodes/" + zip + "> wh:weather_for <http://www.example.com/WeatherHealth/ZipCodes/" + zip + "/" + today + "> ."
	print >>output, "<http://www.example.com/WeatherHealth/ZipCodes/" + zip + "/" + today + ">"
	
	# Only print values that are present
	if (maxTemp):
		print >>output, " wh:max_temp " + maxTemp
	if (minTemp):
		print >>output, " ; wh:min_temp " + minTemp
	if (uvValue):
		print >>output, " ; wh:uv_value " + uvValue
		
	if (uvAlert == "0"):
		print >>output, " ; wh:uv_alert \"False\""
	elif (uvAlert == "1"):
	 	print >>output, " ; wh:uv_alert \"True\""
	 	
	print >>output, ". \n";

# Close zip code input and Turtle output files
input.close()
output.close()
 
print "Loading Data..."
args2 = ["./s-put", "http://localhost:3030/ds/data", "default", "/Users/LukeRuth/Desktop/LinkedData_WeatherHealthApp/Chapter7/weatherData.ttl"]
subprocess.Popen(args2)

sleep(10) 
print "\n"
 
print "Executing Query..."
args3 = ["./s-query", "--service", "http://localhost:3030/ds/query", "SELECT ?day ?maxTemp ?uvValue WHERE { ?day <http://www.example.com/WeatherHealth/Schema#max_temp> ?maxTemp ; <http://www.example.com/WeatherHealth/Schema#uv_value> ?uvValue . } LIMIT 1"]
subprocess.Popen(args3)

sleep(10) 
print "\nScript Complete.\n"
